@echo off
if "%OS%" == "Windows_NT" setlocal

if "%JOBSERVER_HOME%" == "" goto guessIt
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome

:guessIt
set JOBSERVER_HOME=.
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
rem Try to guess what JOBSERVER_HOME is
set JOBSERVER_HOME=..

if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
set JOBSERVER_HOME=..\..
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
echo  The JOBSERVER_HOME environment variable is not set. This
echo  variable needs to be set to run this program. Program
echo  exiting.
goto end

:okHome

if exist "%JAVA_HOME%\bin\java.exe" goto okExecJDK

if exist "%JRE_HOME%\bin\java.exe" goto okExecJRE
echo "Neither JRE_HOME nor JAVA_HOME environment variable is set."
echo "One of these variables must be set to run this program."
echo "Program exiting."
goto end

:okExecJRE
set JS_JVM_HOME=%JRE_HOME%
goto okHome0

:okExecJDK
set JS_JVM_HOME=%JAVA_HOME%

:okHome0

for /F "usebackq" %%i IN (`hostname`) DO set jshost=%%i
set JS_SERVER_HOSTNAME=%jshost%
if "%JOBSERVER_HOSTNAME%" == "" goto stepLocalhost
set JS_SERVER_HOSTNAME=%JOBSERVER_HOSTNAME%
:stepLocalhost

if not "%1" == "-stop" GOTO okAnother1

rem -------STOP COMMAND --------

call "%JOBSERVER_HOME%\bin\jsshutdown.bat" -nopause
goto end

:okAnother1
if not "%1" == "-start" GOTO okAnother2

rem -------START COMMAND--------

rem hstart puts JS into previous state it was on before crash
set containerStartupMode=hstart
call "%JOBSERVER_HOME%\bin\jsstartup.bat" -background -nopause

for /F "usebackq delims=," %%i IN (`date /t`) DO set JS_DATE=%%i
echo "created for jobserver locking - %JS_DATE%" > "%JOBSERVER_HOME%\EJS-DATA\startup-log\%JS_SERVER_HOSTNAME%\winservice.lck"

:loopme
IF NOT EXIST "%JOBSERVER_HOME%\EJS-DATA\startup-log\%JS_SERVER_HOSTNAME%\winservice.lck" GOTO end
call "%JOBSERVER_HOME%\bin\toolbin\sleep.exe" 10
GOTO loopme


:okAnother2
if not "%1" == "-restart" GOTO okAnother3

rem -------RESTART COMMAND-------

call "%JOBSERVER_HOME%\bin\jsshutdown.bat" -nopause
call "%JOBSERVER_HOME%\bin\toolbin\sleep" 10

set containerStartupMode=hstart
call "%JOBSERVER_HOME%\bin\jsstartup.bat" -background -nopause

for /F "usebackq delims=," %%i IN (`date /t`) DO set JS_DATE=%%i
echo "created for jobserver locking - %JS_DATE%" > "%JOBSERVER_HOME%\EJS-DATA\startup-log\%JS_SERVER_HOSTNAME%\winservice.lck"

:loopme
IF NOT EXIST "%JOBSERVER_HOME%\EJS-DATA\startup-log\%JS_SERVER_HOSTNAME%\winservice.lck" GOTO end
call "%JOBSERVER_HOME%\bin\toolbin\sleep.exe" 10
GOTO loopme

:okAnother3

echo.
echo JobServer Windows Service Wrapper: command not recognized: %1
echo   Valid commands: -start, -stop, -restart
echo.

:end
